package user;

sub lock {
	my $count;
	my $t;

	if (!-d "./user") {
		mkdir("./user");
	}

	$count = 10;

	while (!mkdir("./user/lock")) {
		$t = (stat("./user/lock"))[9];
		if ($t < time() - 10) {
			unlock();
		}
		$count--;
		if ($count == 0) {
			return -1;
		}
		sleep(1);
	}

	return 0;
}

sub unlock {
	rmdir("./user/lock");
}

sub add {
	my $uid;
	my $name;
	my $password;
	my $max_uid = "0000";

	($name, $password) = @_;

	if (!-d "./user") {
		mkdir("./user");
	}

	if (lock() < 0) {
		return -1;
	}

	open(PASSWORDFILE, "./user/password.txt");
	while (<PASSWORDFILE>) {
		s/^\s+//;
		s/\s+$//;
		if (/^#/ || ($_ eq "")) {
			next;
		}
		($uid) = split('\s+');
		if ($max_uid lt $uid) {
			$max_uid = $uid;
		}
	}
	close(PASSWORDFILE);

	$uid = "0000" . ($uid + 1);
	($uid) = $uid =~ /(\d\d\d\d)$/;

	open(PASSWORDFILE, ">> ./user/password.txt");
	print PASSWORDFILE "\t$uid\t$name\t$password\n";
	close(PASSWORDFILE);

	unlock();
}

sub list {
	my $uid;
	my $name;
	my $password;
	my @list;

	@list = ();

	open(PASSWORDFILE, "./user/password.txt");
	while (<PASSWORDFILE>) {
		s/^\s+//;
		s/\s+$//;
		if (/^#/ || ($_ eq "")) {
			next;
		}
		($uid, $name, $password) = split('\s+');
		push(@list, $uid);
	}
	close(PASSWORDFILE);

	return @list;
}

sub get_uid {
	my $search_name;
	my $uid;
	my $name;
	my $password;

	($search_name) = @_;

	open(PASSWORDFILE, "./user/password.txt");
	while (<PASSWORDFILE>) {
		s/^\s+//;
		s/\s+$//;
		if (/^#/ || ($_ eq "")) {
			next;
		}
		($uid, $name, $password) = split('\s+');
		if ($search_name ne $name) {
			next;
		}
		close(PASSWORDFILE);
		return $uid;
	}
	close(PASSWORDFILE);

	return "";
}

sub get_name {
	my $uid;
	my $name;
	my $password;

	($uid) = @_;
	($uid, $name, $password) = readfile($uid);
	return $name;
}

sub is_valid {
	my $search_uid;
	my $uid;
	my $name;
	my $password;

	($search_uid) = @_;
	($uid, $name, $password) = readfile($search_uid);
	if ($search_uid ne $uid) {
		return 0;
	}
	return 1;
}

sub readfile {
	my $search_uid;
	my $uid;
	my $name;
	my $password;

	($search_uid) = @_;

	open(PASSWORDFILE, "./user/password.txt");
	while (<PASSWORDFILE>) {
		s/^\s+//;
		s/\s+$//;
		if (/^#/ || ($_ eq "")) {
			next;
		}
		($uid, $name, $password) = split('\s+');
		if ($search_uid ne $uid) {
			next;
		}
		close(PASSWORDFILE);
		return ($uid, $name, $password);
	}
	close(PASSWORDFILE);

	return "";
}

1;
