#!/usr/bin/perl

use strict;
use CGI;
use CGI::Session;

require 'config.pl';
require 'lib/cgilib.pl';
require 'lib/session.pl';
require 'lib/user.pl';

my $cgi = CGI->new;
my $session_id;
my $session;

($session_id, $session) = session::check($cgi);

my $uid = $session->param('uid');
if (!user::is_valid($uid)) {
	cgilib::header($cgi, "Error");
	print '<center><h1>';
	print 'Invalid User!<p>';
	print '<a href="login.cgi">Login</a>';
	print '</h1></center>';
	cgilib::footer($cgi);
	exit;
}

my $name = user::get_name($uid);

$session->delete();

cgilib::header($cgi, "Logout");
print '<center><h1>';
print "$name is logout.<br>";
print '<a href="login.cgi">Login</a>';
print '</center></h1>';
cgilib::footer($cgi);
